<!DOCTYPE html>
<html>

<head>
    <title>Page one of the calculation quiz</title>
</head>

<body>

    <div class="main-container">
        <div class="results-container">
            <img class="questions-table-cell-result-image" src=".\ressources\report-page\results_new.png"
                width=60%></img>
            <div class="height-wrapper">
                <div class="outer-container">
                    <table class="questions-table">
                        <tr>
                            <th style="text-align: left; width: 60%;">Frage</th>
                            <th style="text-align: center; width: 10%;">Ergebnis</th>
                            <th style="text-align: right; width: 30%;">Zeit</th>
                        </tr>
                        <tr>
                            <td class="questions-table-cell-question">Frage 1</td>
                            <td class="questions-table-cell-result">
                                <img class="questions-table-cell-result-image"
                                     src=".\ressources\report-page\correct.png" width=30%></img>
                            </td>
                            <td class="questions-table-cell-time">00:09</td>
                        </tr>
                        <tr>
                            <td class="questions-table-cell-question">Frage 2</td>
                            <td class="questions-table-cell-result">
                                <img class="questions-table-cell-result-image"
                                     src=".\ressources\report-page\correct.png" width=30%></img>
                            </td>
                            <td class="questions-table-cell-time">00:04</td>
                        </tr>
                        <tr>
                            <td class="questions-table-cell-question">Frage 3</td>
                            <td class="questions-table-cell-result">
                                <img class="questions-table-cell-result-image"
                                     src=".\ressources\report-page\wrong.png" width=30%></img>
                            </td>
                            <td class="questions-table-cell-time">00:11</td>
                        </tr>
                        <tr>
                            <td class="questions-table-cell-question">Frage 4</td>
                            <td class="questions-table-cell-result">
                                <img class="questions-table-cell-result-image"
                                     src=".\ressources\report-page\correct.png" width=30%></img>
                            </td>
                            <td class="questions-table-cell-time">00:12</td>
                        </tr>
                        <tr>
                            <td class="questions-table-cell-question">Frage 5</td>
                            <td class="questions-table-cell-result">
                                <img class="questions-table-cell-result-image"
                                     src=".\ressources\report-page\wrong.png" width=30%></img>
                            </td>
                            <td class="questions-table-cell-time">00:08</td>
                        </tr>
                    </table>
                    <button class="button-wrapper-bottom"><a style="text-decoration: none;color: black; width:100%" href="./Selection.html">Review Questions</a></button>
                </div>
            </div>
        </div>
        <div class="ranking-container">
            <img class="questions-table-cell-result-image" src=".\ressources\report-page\ranking_new.png"
                width=70%></img>
            <div class="height-wrapper">
                <div class="outer-container">
                    <table class="ranking-table" id="ranking-table">
                        <tr>
                            <th class="text-style-table-header" style="text-align: left; width: 10%;">Ranking</th>
                            <th class="text-style-table-header" style="text-align: left; width: 50%;">Name</th>
                            <th class="text-style-table-header" style="text-align: center; width: 10%;">Gesamtzeit</th>
                            <th class="text-style-table-header" style="text-align: right; width: 30%;">Punkte</th>
                        </tr>

                    </table>
                </div>
            </div>
        </div>
        <div class="stats-container">
            <img class="questions-table-cell-result-image" src=".\ressources\report-page\stats_new.png"
                width=60%></img>
            <div class="height-wrapper">
                <div class="outer-container">
                    <canvas id="myChart"></canvas>
                    <button class="button-wrapper-bottom"><a style="text-decoration: none;color: black; width:100%" href="./Selection.html">New Try</a></button>
                </div>
            </div>
        </div>
    </div>
    <script src="https://cdn.jsdelivr.net/npm/chart.js"></script>
    <script
        src="https://cdn.jsdelivr.net/npm/chartjs-adapter-date-fns/dist/chartjs-adapter-date-fns.bundle.min.js"></script>
    <script src="./scripts/statistics.js"></script>
    <script>
        const statisticsHelper = new StatisticsHelper("exampleName");
        const runs = statisticsHelper.statistics.runs;
        const mathRuns = runs.filter(run => run.type == "maths")
        const pyhsicsRuns = runs.filter(run => run.type == "physics")
        const csRuns = runs.filter(run => run.type == "cs")


    </script>
    <script>


        const ctx = document.getElementById('myChart');
        new Chart(ctx, {
            type: 'line',
            data: {
                labels: [...new Set([
                    ...mathRuns.map(run => run.started),
                    ...pyhsicsRuns.map(run => run.started),
                    ...csRuns.map(run => run.started)
                ])],
                datasets: [{
                    label: 'Score - Math',
                    data: mathRuns.map(run => {
                        return {
                            x: run.started,
                            y: run.total_score
                        }
                    }),
                    borderWidth: 1
                }, {
                    label: 'Score - Physics',
                    data: pyhsicsRuns.map(run => {
                        return {
                            x: run.started,
                            y: run.total_score
                        }
                    }),
                    borderWidth: 1
                }, {
                    label: 'Score - CS',
                    data: csRuns.map(run => {
                        return {
                            x: run.started,
                            y: run.total_score
                        }
                    }),
                    borderWidth: 1
                }]
            },
            options: {
                scales: {
                    y: {
                        beginAtZero: true,
                        title: {
                            display: true,
                            text: 'Score'
                        }
                    },
                    x: {
                        type: 'time',
                        time: {
                            tooltipFormat: 'DD T'
                        },
                        title: {
                            display: true,
                            text: 'Datum'
                        }

                    }
                }
            }
        });
    </script>
    <script>
        const table = document.getElementById("ranking-table");
        const tBody = table.getElementsByTagName("tbody")[0];
        // Take all the runs and sort them by the the amount of correct answers and the time
        const sortedRuns = runs.sort((a, b) => {
            // If the have the same amount of correct answers, sort by time
            if (a.results.length == b.results.length) {

                return (a.ended - a.started) - (b.ended - b.started);
            }
            return b.results.length - a.results.length;
        });
        for (const runIndex in sortedRuns) {
            const run = sortedRuns[runIndex];
            const tr = document.createElement("tr");

            // Create ranking
            const tdRank = document.createElement("td");
            tdRank.className = "text-style-table"
            tdRank.style = "text-align:center"
            tdRank.innerHTML = parseInt(runIndex) + 1;
            tr.appendChild(tdRank);
            // Create name
            const tdName = document.createElement("td");
            tdName.className = "text-style-table"
            tdName.innerHTML = run.userName;
            tr.appendChild(tdName);
            // Create time
            const tdTime = document.createElement("td");
            tdTime.className = "text-style-table"
            tdTime.style = "text-align: center"
            tdTime.innerHTML = new Date(run.ended - run.started).toISOString().substr(11, 8);
            tr.appendChild(tdTime);
            // Create points
            const tdPoints = document.createElement("td");
            tdPoints.className = "text-style-table"
            tdPoints.style = "text-align: center"
            tdPoints.innerHTML = run.total_score;
            tr.appendChild(tdPoints);
            tBody.appendChild(tr);
        }
    </script>
    <style>

        .button-wrapper-bottom {
            font-size: 45px;
            position: absolute;
            right:    0;
            bottom:   0;
            width: 100%;
            color="#000000";
            justify-content: center;
            color: var(--Azul-Primrio, #5970e7);
            text-align: center;
            border-radius: 10px;
            background-color: rgba(0, 184, 252, 1);
            margin-top: 34px;
            align-items: center;
            padding: 26px 20px 26px 34px;
            font: 700 30px/30px Yanone Kaffeesatz, -apple-system, Roboto, Helvetica,
            sans-serif;
        }

        .text-style-table {
            font-size: 26px;
        }

        .text-style-table-header {
            font-size: 25px;
        }

        .questions-table-cell-question {
            text-align: left;
        }

        .questions-table-cell-result {
            text-align: center;
        }

        questions-table-cell-result-image {
            width: 10px;
            height: 10px;
        }

        .questions-table-cell-time {
            text-align: right;
        }

        questions-table {
            position: absolute;
            left:    0;
            top:   0;
            width: 100%;
            justify-content: center;
            width: 100%;
            border: 1px solid black;
        }

        .ranking-table {
            justify-content: center;
            float: center;
            display: flex;
            width: 100%;
        }

        .stats-div {
            justify-content: center;
            float: center;
            display: flex;
            flex-direction: row;
            flex-grow: 0.6;
            width: 100%
        }

        .height-wrapper {
            justify-content: center;
            float: top;
            flex-wrap:wrap;
            display: flex;
            flex-direction: row;
            flex-grow: 0.6;
            width: 100%
        }

        .inner-height-wrapper {
            justify-content: center;
            float: center;
            display: flex;
            flex-wrap:wrap;
            flex-direction: row;
            flex-grow: 0.8;
            width: 100%
        }

        .inner-container {
            display: flex;
            justify-content: center;
            float: center;
            flex-direction: row;
            flex-grow: 0.2;
            background-image: url("./ressources/report-page/table_back.png");
            background-size: 100% 100%;
            width: 30%;
        }

        .outer-container {
            display: flex;
            flex-wrap:wrap;
            flex: 1; /* additionally, equal width */
            position:relative;
            padding: 5em;
            border: solid;
            justify-content: center;
            float: top;
            background-image: url("./ressources/report-page/table_back.png");
            background-size: 100% 100%;
            flex-direction: row;
            flex-grow: 0.7;
            width: 60%;
            border-top-left-radius: 10px;
            border-radius: 10px;
        }

        .title {
            display: flex;
            color: red;
        }

        .main-container {
            background-color: rgb(49, 49, 49, 1);
            background-size: 100% 100%;
            display: flex;
            height: 100vh;
        }


        .stats-container, .results-container {
            align-items: center;
            display: flex;
            flex-direction: column;
            justify-content: center;
            float: center;
            width: 60%;
            height: 60%;
            padding: 5em;
        }

        .ranking-container {
            align-items: center;
            display: flex;
            flex-direction: column;
            height: 100vh;
            justify-content: center;
            float: center;
        }


    </style>
</body>



</html>